##// END OF EJS Templates
""
Unknown -
r667:741b0f73846d
parent child
Show More
@@ -1,895 +1,895
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47 if [ $RELEASE = bullseye] ; then
47 if [ $RELEASE = "bullseye" ] ; then
48 RELEASE=testing
48 RELEASE=testing
49 fi
49 fi
50
50
51 # Kernel Branch
51 # Kernel Branch
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
52 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53
53
54 # URLs
54 # URLs
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
55 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
56 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
58 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
59 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
60 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
61 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
62 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
63 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64
64
65 # Kernel deb packages for 32bit kernel
65 # Kernel deb packages for 32bit kernel
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
69 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
70 # Default precompiled 64bit kernel
70 # Default precompiled 64bit kernel
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
71 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
72 # Sakaki BIS Kernel RPI4
72 # Sakaki BIS Kernel RPI4
73 RPI4_64_DEF_KERNEL_URL=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz
73 RPI4_64_DEF_KERNEL_URL=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.59.20190724/bcm2711-kernel-bis-4.19.59.20190724.tar.xz
74 # Generic
74 # Generic
75 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
75 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
76 RPI4_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
76 RPI4_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
77 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
77 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
78 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
78 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
79
79
80 # Build directories
80 # Build directories
81 WORKDIR=$(pwd)
81 WORKDIR=$(pwd)
82 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
82 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
83 BUILDDIR="${BASEDIR}/build"
83 BUILDDIR="${BASEDIR}/build"
84
84
85 # Chroot directories
85 # Chroot directories
86 R="${BUILDDIR}/chroot"
86 R="${BUILDDIR}/chroot"
87 ETC_DIR="${R}/etc"
87 ETC_DIR="${R}/etc"
88 LIB_DIR="${R}/lib"
88 LIB_DIR="${R}/lib"
89 BOOT_DIR="${R}/boot/firmware"
89 BOOT_DIR="${R}/boot/firmware"
90 KERNEL_DIR="${R}/usr/src/linux"
90 KERNEL_DIR="${R}/usr/src/linux"
91 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
91 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
92 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
92 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
93
93
94 # Firmware directory: Blank if download from github
94 # Firmware directory: Blank if download from github
95 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
95 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
96
96
97 # General settings
97 # General settings
98 SET_ARCH=${SET_ARCH:=32}
98 SET_ARCH=${SET_ARCH:=32}
99 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
99 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
100 PASSWORD=${PASSWORD:=raspberry}
100 PASSWORD=${PASSWORD:=raspberry}
101 USER_PASSWORD=${USER_PASSWORD:=raspberry}
101 USER_PASSWORD=${USER_PASSWORD:=raspberry}
102 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
102 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
103 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
103 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
104 EXPANDROOT=${EXPANDROOT:=true}
104 EXPANDROOT=${EXPANDROOT:=true}
105 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
105 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
106
106
107 # Keyboard settings
107 # Keyboard settings
108 XKB_MODEL=${XKB_MODEL:=""}
108 XKB_MODEL=${XKB_MODEL:=""}
109 XKB_LAYOUT=${XKB_LAYOUT:=""}
109 XKB_LAYOUT=${XKB_LAYOUT:=""}
110 XKB_VARIANT=${XKB_VARIANT:=""}
110 XKB_VARIANT=${XKB_VARIANT:=""}
111 XKB_OPTIONS=${XKB_OPTIONS:=""}
111 XKB_OPTIONS=${XKB_OPTIONS:=""}
112
112
113 # Network settings (DHCP)
113 # Network settings (DHCP)
114 ENABLE_DHCP=${ENABLE_DHCP:=true}
114 ENABLE_DHCP=${ENABLE_DHCP:=true}
115
115
116 # Network settings (static)
116 # Network settings (static)
117 NET_ADDRESS=${NET_ADDRESS:=""}
117 NET_ADDRESS=${NET_ADDRESS:=""}
118 NET_GATEWAY=${NET_GATEWAY:=""}
118 NET_GATEWAY=${NET_GATEWAY:=""}
119 NET_DNS_1=${NET_DNS_1:=""}
119 NET_DNS_1=${NET_DNS_1:=""}
120 NET_DNS_2=${NET_DNS_2:=""}
120 NET_DNS_2=${NET_DNS_2:=""}
121 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
121 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
122 NET_NTP_1=${NET_NTP_1:=""}
122 NET_NTP_1=${NET_NTP_1:=""}
123 NET_NTP_2=${NET_NTP_2:=""}
123 NET_NTP_2=${NET_NTP_2:=""}
124
124
125 # APT settings
125 # APT settings
126 APT_PROXY=${APT_PROXY:=""}
126 APT_PROXY=${APT_PROXY:=""}
127 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
127 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
128 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
128 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
129
129
130 # Feature settings
130 # Feature settings
131 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
131 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
132 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
132 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
133 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
133 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
134 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
134 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
135 ENABLE_I2C=${ENABLE_I2C:=false}
135 ENABLE_I2C=${ENABLE_I2C:=false}
136 ENABLE_SPI=${ENABLE_SPI:=false}
136 ENABLE_SPI=${ENABLE_SPI:=false}
137 ENABLE_IPV6=${ENABLE_IPV6:=true}
137 ENABLE_IPV6=${ENABLE_IPV6:=true}
138 ENABLE_SSHD=${ENABLE_SSHD:=true}
138 ENABLE_SSHD=${ENABLE_SSHD:=true}
139 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
139 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
140 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
140 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
141 ENABLE_SOUND=${ENABLE_SOUND:=true}
141 ENABLE_SOUND=${ENABLE_SOUND:=true}
142 ENABLE_DBUS=${ENABLE_DBUS:=true}
142 ENABLE_DBUS=${ENABLE_DBUS:=true}
143 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
143 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
144 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
144 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
145 ENABLE_XORG=${ENABLE_XORG:=false}
145 ENABLE_XORG=${ENABLE_XORG:=false}
146 ENABLE_WM=${ENABLE_WM:=""}
146 ENABLE_WM=${ENABLE_WM:=""}
147 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
147 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
148 ENABLE_USER=${ENABLE_USER:=true}
148 ENABLE_USER=${ENABLE_USER:=true}
149 USER_NAME=${USER_NAME:="pi"}
149 USER_NAME=${USER_NAME:="pi"}
150 ENABLE_ROOT=${ENABLE_ROOT:=false}
150 ENABLE_ROOT=${ENABLE_ROOT:=false}
151 ENABLE_QEMU=${ENABLE_QEMU:=false}
151 ENABLE_QEMU=${ENABLE_QEMU:=false}
152 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
152 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
153
153
154 # SSH settings
154 # SSH settings
155 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
155 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
156 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
156 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
157 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
157 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
158 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
158 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
159 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
159 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
160
160
161 # Advanced settings
161 # Advanced settings
162 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
162 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
163 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
163 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
164 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
164 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
165 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
165 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
166 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
166 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
167 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
167 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
168 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
168 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
169 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
169 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
170 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
170 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
171 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
171 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
172 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
172 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
173 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
173 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
174 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
174 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
175 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
175 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
176 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
176 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
177 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
177 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
178 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
178 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
179 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
179 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
180 ENABLE_LOGO=${ENABLE_LOGO:=true}
180 ENABLE_LOGO=${ENABLE_LOGO:=true}
181 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
181 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
182 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
182 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
183
183
184 # Kernel compilation settings
184 # Kernel compilation settings
185 BUILD_KERNEL=${BUILD_KERNEL:=true}
185 BUILD_KERNEL=${BUILD_KERNEL:=true}
186 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
186 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
187 KERNEL_THREADS=${KERNEL_THREADS:=1}
187 KERNEL_THREADS=${KERNEL_THREADS:=1}
188 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
188 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
189 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
189 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
190 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
190 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
191 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
191 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
192 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
192 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
193 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
193 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
194 KERNEL_VIRT=${KERNEL_VIRT:=false}
194 KERNEL_VIRT=${KERNEL_VIRT:=false}
195 KERNEL_BPF=${KERNEL_BPF:=false}
195 KERNEL_BPF=${KERNEL_BPF:=false}
196 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
196 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
197 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
197 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
198 KERNEL_NF=${KERNEL_NF:=false}
198 KERNEL_NF=${KERNEL_NF:=false}
199 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
199 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
200 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
200 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
201 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
201 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
202 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
202 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
203
203
204 # Kernel compilation from source directory settings
204 # Kernel compilation from source directory settings
205 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
205 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
206 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
206 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
207 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
207 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
208 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
208 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
209
209
210 # Reduce disk usage settings
210 # Reduce disk usage settings
211 REDUCE_APT=${REDUCE_APT:=true}
211 REDUCE_APT=${REDUCE_APT:=true}
212 REDUCE_DOC=${REDUCE_DOC:=true}
212 REDUCE_DOC=${REDUCE_DOC:=true}
213 REDUCE_MAN=${REDUCE_MAN:=true}
213 REDUCE_MAN=${REDUCE_MAN:=true}
214 REDUCE_VIM=${REDUCE_VIM:=false}
214 REDUCE_VIM=${REDUCE_VIM:=false}
215 REDUCE_BASH=${REDUCE_BASH:=false}
215 REDUCE_BASH=${REDUCE_BASH:=false}
216 REDUCE_HWDB=${REDUCE_HWDB:=true}
216 REDUCE_HWDB=${REDUCE_HWDB:=true}
217 REDUCE_SSHD=${REDUCE_SSHD:=true}
217 REDUCE_SSHD=${REDUCE_SSHD:=true}
218 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
218 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
219
219
220 # Encrypted filesystem settings
220 # Encrypted filesystem settings
221 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
221 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
222 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
222 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
223 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
223 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
224 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
224 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
225 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
225 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
226 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
226 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
227 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
227 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
228 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
228 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
229 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
229 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
230
230
231 # Chroot scripts directory
231 # Chroot scripts directory
232 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
232 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
233
233
234 # Packages required in the chroot build environment
234 # Packages required in the chroot build environment
235 APT_INCLUDES=${APT_INCLUDES:=""}
235 APT_INCLUDES=${APT_INCLUDES:=""}
236 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
236 APT_INCLUDES="${APT_INCLUDES},flex,bison,libssl-dev,apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
237
237
238 # Packages to exclude from chroot build environment
238 # Packages to exclude from chroot build environment
239 APT_EXCLUDES=${APT_EXCLUDES:=""}
239 APT_EXCLUDES=${APT_EXCLUDES:=""}
240
240
241 # Packages required for bootstrapping
241 # Packages required for bootstrapping
242 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
242 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
243 MISSING_PACKAGES=""
243 MISSING_PACKAGES=""
244
244
245 # Packages installed for c/c++ build environment in chroot (keep empty)
245 # Packages installed for c/c++ build environment in chroot (keep empty)
246 COMPILER_PACKAGES=""
246 COMPILER_PACKAGES=""
247
247
248 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
248 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
249 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
249 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
250 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
250 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
251 APT_PROXY=http://127.0.0.1:3142/
251 APT_PROXY=http://127.0.0.1:3142/
252 fi
252 fi
253
253
254 # Setup architecture specific settings
254 # Setup architecture specific settings
255 if [ -n "$SET_ARCH" ] ; then
255 if [ -n "$SET_ARCH" ] ; then
256 # 64-bit configuration
256 # 64-bit configuration
257 if [ "$SET_ARCH" = 64 ] ; then
257 if [ "$SET_ARCH" = 64 ] ; then
258 # General 64-bit depended settings
258 # General 64-bit depended settings
259 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
259 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
260 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
260 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
261 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
261 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
262
262
263 # Raspberry Pi model specific settings
263 # Raspberry Pi model specific settings
264 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
264 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
265 if [ "$RPI_MODEL" != 4 ] ; then
265 if [ "$RPI_MODEL" != 4 ] ; then
266 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
266 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
267 else
267 else
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
269 fi
269 fi
270
270
271 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
271 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
272 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
272 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
273 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
273 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
274 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
274 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
275 else
275 else
276 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
276 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
277 exit 1
277 exit 1
278 fi
278 fi
279 fi
279 fi
280
280
281 # 32-bit configuration
281 # 32-bit configuration
282 if [ "$SET_ARCH" = 32 ] ; then
282 if [ "$SET_ARCH" = 32 ] ; then
283 # General 32-bit dependend settings
283 # General 32-bit dependend settings
284 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
284 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
285 KERNEL_ARCH=${KERNEL_ARCH:=arm}
285 KERNEL_ARCH=${KERNEL_ARCH:=arm}
286 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
286 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
287
287
288 # Raspberry Pi model specific settings
288 # Raspberry Pi model specific settings
289 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
289 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
290 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
290 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
291 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
291 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
292 RELEASE_ARCH=${RELEASE_ARCH:=armel}
292 RELEASE_ARCH=${RELEASE_ARCH:=armel}
293 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
293 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
294 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
294 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
295 fi
295 fi
296
296
297 # Raspberry Pi model specific settings
297 # Raspberry Pi model specific settings
298 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
298 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
299 if [ "$RPI_MODEL" != 4 ] ; then
299 if [ "$RPI_MODEL" != 4 ] ; then
300 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
300 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
301 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
301 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
302 else
302 else
303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
304 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
304 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
305 fi
305 fi
306
306
307 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
307 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
308 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
308 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
309
309
310 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
310 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
311 fi
311 fi
312 fi
312 fi
313 # SET_ARCH not set
313 # SET_ARCH not set
314 else
314 else
315 echo "error: Please set '32' or '64' as value for SET_ARCH"
315 echo "error: Please set '32' or '64' as value for SET_ARCH"
316 exit 1
316 exit 1
317 fi
317 fi
318 # Device specific configuration and U-Boot configuration
318 # Device specific configuration and U-Boot configuration
319 case "$RPI_MODEL" in
319 case "$RPI_MODEL" in
320 0)
320 0)
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 ;;
323 ;;
324 1)
324 1)
325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 ;;
327 ;;
328 1P)
328 1P)
329 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
329 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
331 ;;
331 ;;
332 2)
332 2)
333 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
333 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
335 ;;
335 ;;
336 3)
336 3)
337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
339 ;;
339 ;;
340 3P)
340 3P)
341 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
341 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
342 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
342 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
343 ;;
343 ;;
344 4)
344 4)
345 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
345 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
346 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
346 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
347 ;;
347 ;;
348 *)
348 *)
349 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
349 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
350 exit 1
350 exit 1
351 ;;
351 ;;
352 esac
352 esac
353
353
354 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
354 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
355 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
355 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
356 # Include bluetooth packages on supported boards
356 # Include bluetooth packages on supported boards
357 if [ "$ENABLE_BLUETOOTH" = true ] ; then
357 if [ "$ENABLE_BLUETOOTH" = true ] ; then
358 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
358 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
359 fi
359 fi
360 if [ "$ENABLE_WIRELESS" = true ] ; then
360 if [ "$ENABLE_WIRELESS" = true ] ; then
361 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
361 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb"
362 fi
362 fi
363 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
363 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
364 # Check if the internal wireless interface is not supported by the RPi model
364 # Check if the internal wireless interface is not supported by the RPi model
365 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
365 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
366 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
366 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
367 exit 1
367 exit 1
368 fi
368 fi
369 fi
369 fi
370
370
371 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
371 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
372 echo "error: You have to compile kernel sources, if you want to enable nexmon"
372 echo "error: You have to compile kernel sources, if you want to enable nexmon"
373 exit 1
373 exit 1
374 fi
374 fi
375
375
376 # Prepare date string for default image file name
376 # Prepare date string for default image file name
377 DATE="$(date +%Y-%m-%d)"
377 DATE="$(date +%Y-%m-%d)"
378 if [ -z "$KERNEL_BRANCH" ] ; then
378 if [ -z "$KERNEL_BRANCH" ] ; then
379 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
379 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
380 else
380 else
381 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
381 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
382 fi
382 fi
383
383
384 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
384 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
385 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
385 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
386 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
386 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
387 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
387 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
388 exit 1
388 exit 1
389 fi
389 fi
390 fi
390 fi
391
391
392 # Add cmake to compile videocore sources
392 # Add cmake to compile videocore sources
393 if [ "$ENABLE_VIDEOCORE" = true ] ; then
393 if [ "$ENABLE_VIDEOCORE" = true ] ; then
394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
395 fi
395 fi
396
396
397 # Add deps for nexmon
397 # Add deps for nexmon
398 if [ "$ENABLE_NEXMON" = true ] ; then
398 if [ "$ENABLE_NEXMON" = true ] ; then
399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
400 fi
400 fi
401
401
402 # Add libncurses5 to enable kernel menuconfig
402 # Add libncurses5 to enable kernel menuconfig
403 if [ "$KERNEL_MENUCONFIG" = true ] ; then
403 if [ "$KERNEL_MENUCONFIG" = true ] ; then
404 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
404 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
405 fi
405 fi
406
406
407 # Add ccache compiler cache for (faster) kernel cross (re)compilation
407 # Add ccache compiler cache for (faster) kernel cross (re)compilation
408 if [ "$KERNEL_CCACHE" = true ] ; then
408 if [ "$KERNEL_CCACHE" = true ] ; then
409 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
409 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
410 fi
410 fi
411
411
412 # Add cryptsetup package to enable filesystem encryption
412 # Add cryptsetup package to enable filesystem encryption
413 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
413 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
414 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
414 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
415 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
415 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
416
416
417 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
417 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
418 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
418 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
419 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
419 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
420 fi
420 fi
421
421
422 if [ -z "$CRYPTFS_PASSWORD" ] ; then
422 if [ -z "$CRYPTFS_PASSWORD" ] ; then
423 echo "error: no password defined (CRYPTFS_PASSWORD)!"
423 echo "error: no password defined (CRYPTFS_PASSWORD)!"
424 exit 1
424 exit 1
425 fi
425 fi
426 ENABLE_INITRAMFS=true
426 ENABLE_INITRAMFS=true
427 fi
427 fi
428
428
429 # Add initramfs generation tools
429 # Add initramfs generation tools
430 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
430 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
431 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
431 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
432 fi
432 fi
433
433
434 # Add device-tree-compiler required for building the U-Boot bootloader
434 # Add device-tree-compiler required for building the U-Boot bootloader
435 if [ "$ENABLE_UBOOT" = true ] ; then
435 if [ "$ENABLE_UBOOT" = true ] ; then
436 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
436 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
437 fi
437 fi
438
438
439 if [ "$ENABLE_USBBOOT" = true ] ; then
439 if [ "$ENABLE_USBBOOT" = true ] ; then
440 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
440 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
441 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
441 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
442 exit 1
442 exit 1
443 fi
443 fi
444 fi
444 fi
445
445
446 # Check if root SSH (v2) public key file exists
446 # Check if root SSH (v2) public key file exists
447 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
447 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
448 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
448 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
449 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
449 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
450 exit 1
450 exit 1
451 fi
451 fi
452 fi
452 fi
453
453
454 # Check if $USER_NAME SSH (v2) public key file exists
454 # Check if $USER_NAME SSH (v2) public key file exists
455 if [ -n "$SSH_USER_PUB_KEY" ] ; then
455 if [ -n "$SSH_USER_PUB_KEY" ] ; then
456 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
456 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
457 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
457 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
458 exit 1
458 exit 1
459 fi
459 fi
460 fi
460 fi
461
461
462 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
462 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
463 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
463 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
464 exit 1
464 exit 1
465 fi
465 fi
466
466
467 # Check if all required packages are installed on the build system
467 # Check if all required packages are installed on the build system
468 for package in $REQUIRED_PACKAGES ; do
468 for package in $REQUIRED_PACKAGES ; do
469 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
469 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
470 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
470 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
471 fi
471 fi
472 done
472 done
473
473
474 # If there are missing packages ask confirmation for install, or exit
474 # If there are missing packages ask confirmation for install, or exit
475 if [ -n "$MISSING_PACKAGES" ] ; then
475 if [ -n "$MISSING_PACKAGES" ] ; then
476 echo "the following packages needed by this script are not installed:"
476 echo "the following packages needed by this script are not installed:"
477 echo "$MISSING_PACKAGES"
477 echo "$MISSING_PACKAGES"
478
478
479 printf "\ndo you want to install the missing packages right now? [y/n] "
479 printf "\ndo you want to install the missing packages right now? [y/n] "
480 read -r confirm
480 read -r confirm
481 [ "$confirm" != "y" ] && exit 1
481 [ "$confirm" != "y" ] && exit 1
482
482
483 # Make sure all missing required packages are installed
483 # Make sure all missing required packages are installed
484 apt-get update
484 apt-get update
485 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
485 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
486 fi
486 fi
487
487
488 # Check if ./bootstrap.d directory exists
488 # Check if ./bootstrap.d directory exists
489 if [ ! -d "./bootstrap.d/" ] ; then
489 if [ ! -d "./bootstrap.d/" ] ; then
490 echo "error: './bootstrap.d' required directory not found!"
490 echo "error: './bootstrap.d' required directory not found!"
491 exit 1
491 exit 1
492 fi
492 fi
493
493
494 # Check if ./files directory exists
494 # Check if ./files directory exists
495 if [ ! -d "./files/" ] ; then
495 if [ ! -d "./files/" ] ; then
496 echo "error: './files' required directory not found!"
496 echo "error: './files' required directory not found!"
497 exit 1
497 exit 1
498 fi
498 fi
499
499
500 # Check if specified KERNELSRC_DIR directory exists
500 # Check if specified KERNELSRC_DIR directory exists
501 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
501 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
502 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
502 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
503 exit 1
503 exit 1
504 fi
504 fi
505
505
506 # Check if specified UBOOTSRC_DIR directory exists
506 # Check if specified UBOOTSRC_DIR directory exists
507 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
507 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
508 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
508 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
509 exit 1
509 exit 1
510 fi
510 fi
511
511
512 # Check if specified VIDEOCORESRC_DIR directory exists
512 # Check if specified VIDEOCORESRC_DIR directory exists
513 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
513 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
514 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
514 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
515 exit 1
515 exit 1
516 fi
516 fi
517
517
518 # Check if specified FBTURBOSRC_DIR directory exists
518 # Check if specified FBTURBOSRC_DIR directory exists
519 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
519 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
520 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
520 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
521 exit 1
521 exit 1
522 fi
522 fi
523
523
524 # Check if specified NEXMONSRC_DIR directory exists
524 # Check if specified NEXMONSRC_DIR directory exists
525 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
525 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
526 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
526 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
527 exit 1
527 exit 1
528 fi
528 fi
529
529
530 # Check if specified CHROOT_SCRIPTS directory exists
530 # Check if specified CHROOT_SCRIPTS directory exists
531 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
531 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
532 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
532 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
533 exit 1
533 exit 1
534 fi
534 fi
535
535
536 # Check if specified device mapping already exists (will be used by cryptsetup)
536 # Check if specified device mapping already exists (will be used by cryptsetup)
537 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
537 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
538 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
538 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
539 exit 1
539 exit 1
540 fi
540 fi
541
541
542 # Don't clobber an old build
542 # Don't clobber an old build
543 if [ -e "$BUILDDIR" ] ; then
543 if [ -e "$BUILDDIR" ] ; then
544 echo "error: directory ${BUILDDIR} already exists, not proceeding"
544 echo "error: directory ${BUILDDIR} already exists, not proceeding"
545 exit 1
545 exit 1
546 fi
546 fi
547
547
548 # Setup chroot directory
548 # Setup chroot directory
549 mkdir -p "${R}"
549 mkdir -p "${R}"
550
550
551 # Check if build directory has enough of free disk space >512MB
551 # Check if build directory has enough of free disk space >512MB
552 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
552 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
553 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
553 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
554 exit 1
554 exit 1
555 fi
555 fi
556
556
557 set -x
557 set -x
558
558
559 # Call "cleanup" function on various signals and errors
559 # Call "cleanup" function on various signals and errors
560 trap cleanup 0 1 2 3 6
560 trap cleanup 0 1 2 3 6
561
561
562 # Add required packages for the minbase installation
562 # Add required packages for the minbase installation
563 if [ "$ENABLE_MINBASE" = true ] ; then
563 if [ "$ENABLE_MINBASE" = true ] ; then
564 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
564 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
565 fi
565 fi
566
566
567 # Add parted package, required to get partprobe utility
567 # Add parted package, required to get partprobe utility
568 if [ "$EXPANDROOT" = true ] ; then
568 if [ "$EXPANDROOT" = true ] ; then
569 APT_INCLUDES="${APT_INCLUDES},parted"
569 APT_INCLUDES="${APT_INCLUDES},parted"
570 fi
570 fi
571
571
572 # Add dphys-swapfile package, required to enable swap
572 # Add dphys-swapfile package, required to enable swap
573 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
573 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
574 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
574 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
575 fi
575 fi
576
576
577 # Add dbus package, recommended if using systemd
577 # Add dbus package, recommended if using systemd
578 if [ "$ENABLE_DBUS" = true ] ; then
578 if [ "$ENABLE_DBUS" = true ] ; then
579 APT_INCLUDES="${APT_INCLUDES},dbus"
579 APT_INCLUDES="${APT_INCLUDES},dbus"
580 fi
580 fi
581
581
582 # Add iptables IPv4/IPv6 package
582 # Add iptables IPv4/IPv6 package
583 if [ "$ENABLE_IPTABLES" = true ] ; then
583 if [ "$ENABLE_IPTABLES" = true ] ; then
584 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
584 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
585 fi
585 fi
586 # Add apparmor for KERNEL_SECURITY
586 # Add apparmor for KERNEL_SECURITY
587 if [ "$KERNEL_SECURITY" = true ] ; then
587 if [ "$KERNEL_SECURITY" = true ] ; then
588 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
588 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
589 fi
589 fi
590
590
591 # Add openssh server package
591 # Add openssh server package
592 if [ "$ENABLE_SSHD" = true ] ; then
592 if [ "$ENABLE_SSHD" = true ] ; then
593 APT_INCLUDES="${APT_INCLUDES},openssh-server"
593 APT_INCLUDES="${APT_INCLUDES},openssh-server"
594 fi
594 fi
595
595
596 # Add alsa-utils package
596 # Add alsa-utils package
597 if [ "$ENABLE_SOUND" = true ] ; then
597 if [ "$ENABLE_SOUND" = true ] ; then
598 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
598 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
599 fi
599 fi
600
600
601 # Add rng-tools package
601 # Add rng-tools package
602 if [ "$ENABLE_HWRANDOM" = true ] ; then
602 if [ "$ENABLE_HWRANDOM" = true ] ; then
603 APT_INCLUDES="${APT_INCLUDES},rng-tools"
603 APT_INCLUDES="${APT_INCLUDES},rng-tools"
604 fi
604 fi
605
605
606 # Add fbturbo video driver
606 # Add fbturbo video driver
607 if [ "$ENABLE_FBTURBO" = true ] ; then
607 if [ "$ENABLE_FBTURBO" = true ] ; then
608 # Enable xorg package dependencies
608 # Enable xorg package dependencies
609 ENABLE_XORG=true
609 ENABLE_XORG=true
610 fi
610 fi
611
611
612 # Add user defined window manager package
612 # Add user defined window manager package
613 if [ -n "$ENABLE_WM" ] ; then
613 if [ -n "$ENABLE_WM" ] ; then
614 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
614 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
615
615
616 # Enable xorg package dependencies
616 # Enable xorg package dependencies
617 ENABLE_XORG=true
617 ENABLE_XORG=true
618 fi
618 fi
619
619
620 # Add xorg package
620 # Add xorg package
621 if [ "$ENABLE_XORG" = true ] ; then
621 if [ "$ENABLE_XORG" = true ] ; then
622 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
622 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
623 fi
623 fi
624
624
625 # Replace selected packages with smaller clones
625 # Replace selected packages with smaller clones
626 if [ "$ENABLE_REDUCE" = true ] ; then
626 if [ "$ENABLE_REDUCE" = true ] ; then
627 # Add levee package instead of vim-tiny
627 # Add levee package instead of vim-tiny
628 if [ "$REDUCE_VIM" = true ] ; then
628 if [ "$REDUCE_VIM" = true ] ; then
629 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
629 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
630 fi
630 fi
631
631
632 # Add dropbear package instead of openssh-server
632 # Add dropbear package instead of openssh-server
633 if [ "$REDUCE_SSHD" = true ] ; then
633 if [ "$REDUCE_SSHD" = true ] ; then
634 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
634 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
635 fi
635 fi
636 fi
636 fi
637
637
638 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
638 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
639 if [ "$ENABLE_SYSVINIT" = false ] ; then
639 if [ "$ENABLE_SYSVINIT" = false ] ; then
640 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
640 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
641 fi
641 fi
642
642
643 # Configure kernel sources if no KERNELSRC_DIR
643 # Configure kernel sources if no KERNELSRC_DIR
644 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
644 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
645 KERNELSRC_CONFIG=true
645 KERNELSRC_CONFIG=true
646 fi
646 fi
647
647
648 # Configure reduced kernel
648 # Configure reduced kernel
649 if [ "$KERNEL_REDUCE" = true ] ; then
649 if [ "$KERNEL_REDUCE" = true ] ; then
650 KERNELSRC_CONFIG=false
650 KERNELSRC_CONFIG=false
651 fi
651 fi
652
652
653 # Configure qemu compatible kernel
653 # Configure qemu compatible kernel
654 if [ "$ENABLE_QEMU" = true ] ; then
654 if [ "$ENABLE_QEMU" = true ] ; then
655 DTB_FILE=vexpress-v2p-ca15_a7.dtb
655 DTB_FILE=vexpress-v2p-ca15_a7.dtb
656 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
656 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
657 KERNEL_DEFCONFIG="vexpress_defconfig"
657 KERNEL_DEFCONFIG="vexpress_defconfig"
658 if [ "$KERNEL_MENUCONFIG" = false ] ; then
658 if [ "$KERNEL_MENUCONFIG" = false ] ; then
659 KERNEL_OLDDEFCONFIG=true
659 KERNEL_OLDDEFCONFIG=true
660 fi
660 fi
661 fi
661 fi
662
662
663 # Execute bootstrap scripts
663 # Execute bootstrap scripts
664 for SCRIPT in bootstrap.d/*.sh; do
664 for SCRIPT in bootstrap.d/*.sh; do
665 head -n 3 "$SCRIPT"
665 head -n 3 "$SCRIPT"
666 . "$SCRIPT"
666 . "$SCRIPT"
667 done
667 done
668
668
669 ## Execute custom bootstrap scripts
669 ## Execute custom bootstrap scripts
670 if [ -d "custom.d" ] ; then
670 if [ -d "custom.d" ] ; then
671 for SCRIPT in custom.d/*.sh; do
671 for SCRIPT in custom.d/*.sh; do
672 . "$SCRIPT"
672 . "$SCRIPT"
673 done
673 done
674 fi
674 fi
675
675
676 # Execute custom scripts inside the chroot
676 # Execute custom scripts inside the chroot
677 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
677 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
678 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
678 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
679 chroot_exec /bin/bash -x <<'EOF'
679 chroot_exec /bin/bash -x <<'EOF'
680 for SCRIPT in /chroot_scripts/* ; do
680 for SCRIPT in /chroot_scripts/* ; do
681 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
681 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
682 $SCRIPT
682 $SCRIPT
683 fi
683 fi
684 done
684 done
685 EOF
685 EOF
686 rm -rf "${R}/chroot_scripts"
686 rm -rf "${R}/chroot_scripts"
687 fi
687 fi
688
688
689 # Remove c/c++ build environment from the chroot
689 # Remove c/c++ build environment from the chroot
690 chroot_remove_cc
690 chroot_remove_cc
691
691
692 # Generate required machine-id
692 # Generate required machine-id
693 MACHINE_ID=$(dbus-uuidgen)
693 MACHINE_ID=$(dbus-uuidgen)
694 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
694 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
695 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
695 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
696
696
697 # APT Cleanup
697 # APT Cleanup
698 chroot_exec apt-get -y clean
698 chroot_exec apt-get -y clean
699 chroot_exec apt-get -y autoclean
699 chroot_exec apt-get -y autoclean
700 chroot_exec apt-get -y autoremove
700 chroot_exec apt-get -y autoremove
701
701
702 # Unmount mounted filesystems
702 # Unmount mounted filesystems
703 umount -l "${R}/proc"
703 umount -l "${R}/proc"
704 umount -l "${R}/sys"
704 umount -l "${R}/sys"
705
705
706 # Clean up directories
706 # Clean up directories
707 rm -rf "${R}/run/*"
707 rm -rf "${R}/run/*"
708 rm -rf "${R}/tmp/*"
708 rm -rf "${R}/tmp/*"
709
709
710 # Clean up APT proxy settings
710 # Clean up APT proxy settings
711 if [ "$KEEP_APT_PROXY" = false ] ; then
711 if [ "$KEEP_APT_PROXY" = false ] ; then
712 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
712 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
713 fi
713 fi
714
714
715 # Clean up files
715 # Clean up files
716 rm -f "${ETC_DIR}/ssh/ssh_host_*"
716 rm -f "${ETC_DIR}/ssh/ssh_host_*"
717 rm -f "${ETC_DIR}/dropbear/dropbear_*"
717 rm -f "${ETC_DIR}/dropbear/dropbear_*"
718 rm -f "${ETC_DIR}/apt/sources.list.save"
718 rm -f "${ETC_DIR}/apt/sources.list.save"
719 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
719 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
720 rm -f "${ETC_DIR}/*-"
720 rm -f "${ETC_DIR}/*-"
721 rm -f "${ETC_DIR}/resolv.conf"
721 rm -f "${ETC_DIR}/resolv.conf"
722 rm -f "${R}/root/.bash_history"
722 rm -f "${R}/root/.bash_history"
723 rm -f "${R}/var/lib/urandom/random-seed"
723 rm -f "${R}/var/lib/urandom/random-seed"
724 rm -f "${R}/initrd.img"
724 rm -f "${R}/initrd.img"
725 rm -f "${R}/vmlinuz"
725 rm -f "${R}/vmlinuz"
726 rm -f "${R}${QEMU_BINARY}"
726 rm -f "${R}${QEMU_BINARY}"
727
727
728 if [ "$ENABLE_QEMU" = true ] ; then
728 if [ "$ENABLE_QEMU" = true ] ; then
729 # Setup QEMU directory
729 # Setup QEMU directory
730 mkdir "${BASEDIR}/qemu"
730 mkdir "${BASEDIR}/qemu"
731
731
732 # Copy kernel image to QEMU directory
732 # Copy kernel image to QEMU directory
733 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
733 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
734
734
735 # Copy kernel config to QEMU directory
735 # Copy kernel config to QEMU directory
736 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
736 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
737
737
738 # Copy kernel dtbs to QEMU directory
738 # Copy kernel dtbs to QEMU directory
739 for dtb in "${BOOT_DIR}/"*.dtb ; do
739 for dtb in "${BOOT_DIR}/"*.dtb ; do
740 if [ -f "${dtb}" ] ; then
740 if [ -f "${dtb}" ] ; then
741 install_readonly "${dtb}" "${BASEDIR}/qemu/"
741 install_readonly "${dtb}" "${BASEDIR}/qemu/"
742 fi
742 fi
743 done
743 done
744
744
745 # Copy kernel overlays to QEMU directory
745 # Copy kernel overlays to QEMU directory
746 if [ -d "${BOOT_DIR}/overlays" ] ; then
746 if [ -d "${BOOT_DIR}/overlays" ] ; then
747 # Setup overlays dtbs directory
747 # Setup overlays dtbs directory
748 mkdir "${BASEDIR}/qemu/overlays"
748 mkdir "${BASEDIR}/qemu/overlays"
749
749
750 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
750 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
751 if [ -f "${dtb}" ] ; then
751 if [ -f "${dtb}" ] ; then
752 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
752 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
753 fi
753 fi
754 done
754 done
755 fi
755 fi
756
756
757 # Copy u-boot files to QEMU directory
757 # Copy u-boot files to QEMU directory
758 if [ "$ENABLE_UBOOT" = true ] ; then
758 if [ "$ENABLE_UBOOT" = true ] ; then
759 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
759 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
760 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
760 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
761 fi
761 fi
762 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
762 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
763 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
763 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
764 fi
764 fi
765 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
765 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
766 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
766 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
767 fi
767 fi
768 fi
768 fi
769
769
770 # Copy initramfs to QEMU directory
770 # Copy initramfs to QEMU directory
771 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
771 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
772 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
772 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
773 fi
773 fi
774 fi
774 fi
775
775
776 # Calculate size of the chroot directory in KB
776 # Calculate size of the chroot directory in KB
777 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
777 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
778
778
779 # Calculate the amount of needed 512 Byte sectors
779 # Calculate the amount of needed 512 Byte sectors
780 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
780 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
781 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
781 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
782 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
782 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
783
783
784 # The root partition is EXT4
784 # The root partition is EXT4
785 # This means more space than the actual used space of the chroot is used.
785 # This means more space than the actual used space of the chroot is used.
786 # As overhead for journaling and reserved blocks 35% are added.
786 # As overhead for journaling and reserved blocks 35% are added.
787 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
787 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
788
788
789 # Calculate required image size in 512 Byte sectors
789 # Calculate required image size in 512 Byte sectors
790 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
790 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
791
791
792 # Prepare image file
792 # Prepare image file
793 if [ "$ENABLE_SPLITFS" = true ] ; then
793 if [ "$ENABLE_SPLITFS" = true ] ; then
794 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
794 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
795 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
795 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
796 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
796 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
797 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
797 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
798
798
799 # Write firmware/boot partition tables
799 # Write firmware/boot partition tables
800 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
800 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
801 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
801 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
802 EOM
802 EOM
803
803
804 # Write root partition table
804 # Write root partition table
805 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
805 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
806 ${TABLE_SECTORS},${ROOT_SECTORS},83
806 ${TABLE_SECTORS},${ROOT_SECTORS},83
807 EOM
807 EOM
808
808
809 # Setup temporary loop devices
809 # Setup temporary loop devices
810 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
810 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
811 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
811 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
812 else # ENABLE_SPLITFS=false
812 else # ENABLE_SPLITFS=false
813 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
813 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
814 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
814 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
815
815
816 # Write partition table
816 # Write partition table
817 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
817 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
818 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
818 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
819 ${ROOT_OFFSET},${ROOT_SECTORS},83
819 ${ROOT_OFFSET},${ROOT_SECTORS},83
820 EOM
820 EOM
821
821
822 # Setup temporary loop devices
822 # Setup temporary loop devices
823 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
823 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
824 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
824 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
825 fi
825 fi
826
826
827 if [ "$ENABLE_CRYPTFS" = true ] ; then
827 if [ "$ENABLE_CRYPTFS" = true ] ; then
828 # Create dummy ext4 fs
828 # Create dummy ext4 fs
829 mkfs.ext4 "$ROOT_LOOP"
829 mkfs.ext4 "$ROOT_LOOP"
830
830
831 # Setup password keyfile
831 # Setup password keyfile
832 touch .password
832 touch .password
833 chmod 600 .password
833 chmod 600 .password
834 echo -n ${CRYPTFS_PASSWORD} > .password
834 echo -n ${CRYPTFS_PASSWORD} > .password
835
835
836 # Initialize encrypted partition
836 # Initialize encrypted partition
837 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
837 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
838
838
839 # Open encrypted partition and setup mapping
839 # Open encrypted partition and setup mapping
840 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
840 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
841
841
842 # Secure delete password keyfile
842 # Secure delete password keyfile
843 shred -zu .password
843 shred -zu .password
844
844
845 # Update temporary loop device
845 # Update temporary loop device
846 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
846 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
847
847
848 # Wipe encrypted partition (encryption cipher is used for randomness)
848 # Wipe encrypted partition (encryption cipher is used for randomness)
849 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
849 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
850 fi
850 fi
851
851
852 # Build filesystems
852 # Build filesystems
853 mkfs.vfat "$FRMW_LOOP"
853 mkfs.vfat "$FRMW_LOOP"
854 mkfs.ext4 "$ROOT_LOOP"
854 mkfs.ext4 "$ROOT_LOOP"
855
855
856 # Mount the temporary loop devices
856 # Mount the temporary loop devices
857 mkdir -p "$BUILDDIR/mount"
857 mkdir -p "$BUILDDIR/mount"
858 mount "$ROOT_LOOP" "$BUILDDIR/mount"
858 mount "$ROOT_LOOP" "$BUILDDIR/mount"
859
859
860 mkdir -p "$BUILDDIR/mount/boot/firmware"
860 mkdir -p "$BUILDDIR/mount/boot/firmware"
861 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
861 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
862
862
863 # Copy all files from the chroot to the loop device mount point directory
863 # Copy all files from the chroot to the loop device mount point directory
864 rsync -a "${R}/" "$BUILDDIR/mount/"
864 rsync -a "${R}/" "$BUILDDIR/mount/"
865
865
866 # Unmount all temporary loop devices and mount points
866 # Unmount all temporary loop devices and mount points
867 cleanup
867 cleanup
868
868
869 # Create block map file(s) of image(s)
869 # Create block map file(s) of image(s)
870 if [ "$ENABLE_SPLITFS" = true ] ; then
870 if [ "$ENABLE_SPLITFS" = true ] ; then
871 # Create block map files for "bmaptool"
871 # Create block map files for "bmaptool"
872 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
872 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
873 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
873 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
874
874
875 # Image was successfully created
875 # Image was successfully created
876 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
876 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
877 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
877 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
878 else
878 else
879 # Create block map file for "bmaptool"
879 # Create block map file for "bmaptool"
880 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
880 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
881
881
882 # Image was successfully created
882 # Image was successfully created
883 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
883 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
884
884
885 # Create qemu qcow2 image
885 # Create qemu qcow2 image
886 if [ "$ENABLE_QEMU" = true ] ; then
886 if [ "$ENABLE_QEMU" = true ] ; then
887 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
887 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
888 QEMU_SIZE=16G
888 QEMU_SIZE=16G
889
889
890 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
890 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
891 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
891 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
892
892
893 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
893 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
894 fi
894 fi
895 fi
895 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant